(*
** RADU support unit for DorInfo?.DEF systems
**
** (c) 1993 Hans Siemons, Prime Productions; All rights reserved.
**
** Last revision : April 2, 1993
*)

{$A+,B-,D+,E-,F+,I+,L-,N-,O+,R-,S+,V-}

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Unit DorInfo;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

interface

Function DorInfoInit:Boolean;
Procedure DorInfoDeInit;


(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

implementation

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses RADU,Dos,MiscRADU;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function DorInfoInit:Boolean;
Var GEDN : String;
Var
  DorInfo     : Text;
  Line        : String[80];
  Line2       : String[50];

begin

  GEDN:=GetEnv('DORINFO');
  DorInfoInit:=False;
  if GEDN='' then exit;
  Assign(DorInfo,Trim(GEDN));
  {$I-}
  reset(DorInfo);
  {$I+}
  if IOREsult<>0 then exit;
  RaNodeNr:=Ord(Gedn[Length(GEDN)-4])-48;
  If GetEnv('DORNODE')<>'' then
    RaNodeNr:=FVal(Trim(GetEnv('DORNODE')));
  If (RaNodeNr<1) or (RaNodeNr>9) then RaNodeNr:=1;
  ReadLn (DorInfo,Line);
  RaConfig.SystemName:=Line;

   ReadLn (DorInfo,Line);
   ReadLn (DorInfo,Line2);
   RaConfig.Sysop:=Trim(Line+' '+Line2);

   ReadLn (DorInfo,Line);
   DorCommPort:=Ord(Line[4])-Ord('0');

   ReadLn (DorInfo,Line);
   Line:=Copy(Line,1,Pos(' ',Line)-1);
   ExitInfo.Baud:=FVal(Line);

   ReadLn (DorInfo,Line);
   If (Line='1') then ExitInfo.WantChat:=True;

   ReadLn (DorInfo,Line);
   ReadLn (DorInfo,Line2);
   ExitInfo.UserInfo.Name:=Trim(Line+' '+Line2);

   ReadLn (DorInfo,Line);
   ExitInfo.UserInfo.Location:=Line;

   ReadLn (DorInfo,Line);
   Begin
     If Line[1] in ['1','3'] then
     Begin
       DorAnsi:=True;
       ExitInfo.UserInfo.Attribute:=ExitInfo.UserInfo.Attribute or 8;
     End; { Ansi }
     If Line[1] in ['2','3'] then
     Begin
       DorAvatar:=True;
       ExitInfo.UserInfo.Attribute2:=ExitInfo.UserInfo.Attribute2 or 2;
     End; { Avatar }
   End;

   ReadLn (DorInfo,Line);
   ExitInfo.UserInfo.Security:=FVal(Line);

   ReadLn (DorInfo,Line);
   ExitInfo.TimeLimit:=FVal(Line);

   With Exitinfo.UserInfo,Exitinfo.UserXIInfo do Begin
     Attribute:=Attribute or 6;
     ScreenLength:=23;
     Attribute2:=Attribute2 or 1;
     Language:=1;
     DateFormat:=1;
   End;

  NoRalFoundErrorDisplay:=False;   { No sence in displaying the .RAL errors }
  DorExtKeys[18]:=DorNullProc;                     { user editor not needed }
  DorExtKeys[49]:=DorNullProc;                      { sysop next not needed }
  DorExtKeys[31]:=DorNullProc;                 { set security is not needed }
  DorInfoInit:=True;
end; { DorInfoInit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure DorInfoDeInit;
begin                { Nothing needed in the De-Initialistation department! }
end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

begin
  AddBBS(DorInfoInit,DorInfoDeInit,'DorInfo?.DEF');
end. { DorInit }
