(*
** RADU support unit for Proboard 2.00 systems
**
** Original (PB 1.30 - modul) is
** Copyright (C) 1993 Berry Cozijnsen for Prime Productions, The Netherlands
**                    All rights reserved.
**
** PB 2.00 adaptation is
***
** (c) Peter Hampf, pbs-data vec, Germany
**
** October 22, 1993, for Prime Productions, The Netherlands
**
** last update: Thu., Nov. 04. 1993
*)

{$A+,B-,D+,E-,F-,I-,L-,N-,O+,R-,S-,V-}

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Unit PB200130;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Interface

Const PB_Detected    : boolean = false;
Var   PB_Ver         : string[4];

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Implementation

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  Radu, RaduSup, Dos, RaStruct, MiscRADU;

Type

  Chr6  = Array[1..6]  of Char;
  Chr9  = Array[1..9]  of Char;
  Chr16 = Array[1..16] of Char;
  Chr26 = Array[1..26] of Char;
  Chr36 = Array[1..36] of Char;
  Chr40 = Array[1..40] of Char;
  chr60 = Array[1..60] of Char;
  Chr61 = Array[1..61] of Char;
  Chr70 = Array[1..70] of Char;
  Chr81 = Array[1..81] of Char;

  DateByte = Array[1..3] of Byte;                       { Day, Mounth, Year }
  TimeByte = Array[1..3] of Byte;                 { Hours, Minutes, Seconds }
  DayFrame = Array[0..5] of Byte;
  TimeFrame= Array[0..6] of DayFrame;                       { Paging Hours! }

  Configrecord_PB200 = record                                  { CONFIG.PRO }
      Shellmsg       : Chr81;               { Message to show when shelling }
      Sysopname      : Chr36;                               { Name of sysop }
      Txtpath,                                         { Path for textfiles }
      Mnupath,                                        { Path for menu-files }
      Msgpath,                                      { Path for message base }
      Uploadpath,                                              { Uploadpath }
      Editorname     : Chr61;                     { Name of external editor }
      Newuserlevel,                                    { Level for new user }
      Newuserloglevel: Integer;                     { Loglevel for new user }
      Newuserflags   : Flagtype;                           { New user flags }
      max_passinput,                  { Maximum attempts for password entry }
      min_passlength,                             { Minimum password length }
      inactivity_time,                          { Inactivity time-out limit }
      max_sysop_pages,                   { Maximum times sysop can be paged }
      pagebell_length,                         { Length of page-bell (secs) }
      mailcheck,                                 { Check for mail at logon? }
      europe,                                       { European date format? }
      numnodes       : Integer;                                   { # nodes }
      allowansi,                                              { Allow ANSI? }
      allowavatar    : Boolean;                             { Allow AVATAR? }
      discrete,                                      { Hide sysop activity? }
      askphone,                                     { Ask for phone number? }
      allowoneword,                                  { Allow one-word names }
      crashlevel     : Integer;                { Level needed for crashmail }
      crashflags     : Flagtype;               { Flags needed for crashmail }
      attachlevel    : Integer;              { Level needed for file attach }
      attachflags    : Flagtype;             { Flags needed for file attach }
      allowmsgupload,                               { Allow message uploads }
      allowstacking  : Integer;                    { Allow command stacking }
      page_start,                                      { Paging hours start }
      page_end       : TimeByte;                         { Paging hours end }
      handshaking,                                        { I/O Handshaking }
      allowalias,                                   { Allow alias for login }
      loglocal,                                           { Log local calls }
      doswap         : Integer;                            { Allow swapping }
      originline,                                             { Origin line }
      nodelistdir    : Chr61;                          { Nodelist directory }
      sysopkeys      : Array[1..10] of Chr60;               { Sysop hotkeys }
      dl_start,                                      { Download hours start }
      dl_end         : TimeByte;                       { Download hours end }
      uploadspace    : Integer;                  { Space needed for uploads }
      pvtuploadpath  : Chr61;                 { Directory for files uploads }
      quotestring    : Chr6;                      { String used for quoting }
      fastmode,                                             { Use fast mode }
      extra_bool_1,
      killsent,                                   { Kill netmail after sent }
      multiline,                                { Use message base sharing? }
      egamode,                                        { Use 43/50 line mode }
      showuserinfo   : Boolean;         { Show user info while in EGA mode? }
      pexpath        : Chr61;                     { Directory for PEX files }
      allowquicklogin,                           { Allow quick sysop login? }
      suspendmsgtime : Boolean;            { Suspend time when writing msgs }
      securityboard  : Integer;            { MsgBoard for security messages }
      pwdmessages,                               { Write security-messages? }
      extra_bool_2   : Boolean;
      bbsname        : Chr36;                             { Name of the BBS }
      pwdchar        : Char;                           { Password character }
      tb_maxtimedeposit,              { Max time deposit per day (TimeBank) }
      tb_maxkbdeposit,              { Max Kbytes deposit per day (TimeBank) }
      tb_maxtimewithdrawal,        { Max time withdrawal per day (TimeBank) }
      tb_maxkbwithdrawal,        { Max Kbytes withdrawal per day (TimeBank) }
      usage_days     : Integer;                 { Days to keep usage graphs }
      systempwd      : Chr16;                             { System password }
      usesystempwd,                                  { Use system password? }
      askbirthdate   : Boolean;                           { Ask Birth Date? }
      binlogdays     : Integer;                { # days to log in BINLOG.PB }
      binloglocal    : Boolean;       { Log local calls to BINLOG.PB yes/no }
      pageArea       : Integer;             { Area number for page messages }
      Indexfiles     : Boolean;            { Use indexed FILES.BBS, obsolet!}
      CheckDupes     : Boolean;                           { Check for Dupes }
      KillDupes      : Boolean;                      { Kill duplicate files }
      Ignore_Ext     : Boolean;          { Dupecheck: ignore file-extension }
      RipPath        : Chr61;                         { Path to RIP-scripts }
      IconsPath      : Chr61;                           { Path to RIP-ICONS }
      Location       : Chr36;                                { Our Location }
      Phone          : Chr26;                               { Our Phone-no. }
      QWKId          : Chr9;                              { QWK - packet-ID }
      IOBuffersize   : word;                           { Size of I/O-Buffer }
      PagingHours    : TimeFrame;                        { The paging-hours }
      DefLanguage    : Chr9;                             { default language }
      AddUploaderName: Boolean;                      { Add uploader's name? }
      DownloadHours  : TimeFrame;                           { Downloadhours }
      AskDataPhone,                       { Some questions to new users ... }
      AskFaxPhone,
      AskAddress,
      AskSex,
      AskDateFormat  : Boolean;
      extra          : Array[1..278] of Byte;
    end; { ConfigRecordPb_200 }

    Modemrecord_PB200 = record                                  { MODEM.PRO }
                   baud,
                   port,
                   quiet,
                   blanktime  : Integer;
                   initstring,
                   busystring : Chr70;
                   initok,
                   busyok,
                   connect300,
                   connect1200,
                   connect2400,
                   connect4800,
                   connect9600,
                   connect19200,
                   connect38400,
                   ring,
                   answer,
                   connect7200,
                   connect12000 : Chr40;
                   forceanswer  : Boolean;
                   extra1       : Array[1..5] of Byte;
                   delay        : Integer;
                   connect14400 : Chr40;
                   initstring2  : Chr70;
                   connect16800,
                   connect28800,
                   ext_connect1,
                   ext_connect2  : Chr40;
                   ext_errlevel1,
                   ext_errlevel2 : Integer;
                   extra         : Array[1..36] of Char;
                end; { ModemRecord_PB200 }

  CombinedRecord_PB200 = Array[1..25] of Byte;

  UsersRecord_PB200   = USERSRecord;
  UsersXIRecord_PB200 = USERSXIRecord;

  UsersRecord_Pb130 = Record                                    { USERS.BBS }
                  Name          : String[35];                { Name of user }
                  Location      : String[25];           { City user is from }
                  Password      : String[15];                    { Password }
                  DataPhone     : String[12];                { Data phone # }
                  VoicePhone    : String[12];               { Voice phone # }
                  LastTime      : Time;                 { Time of last call }
                  LastDate      : Date;                 { Date of last call }
                  Attribute     : Byte;                        { Attributes }
                                                           { Bit 0: Deleted }
                                             { Bit 1: Screen clearing codes }
                                                  { Bit 2: Continue [Y/n/=] }
                                                     { Bit 3: Ansi graphics }
                                              { Bit 4: Don't kill user ever }
                                       { Bit 5: Ignore download restictions }
                                                { Bit 6: Full screen editor }
                                                        { Bit 7: Quiet mode }
                  Flags         : FlagType;         { Flag settings of user }
                  Credit        : Word;                   { Netmail credits }
                  Pending       : Word;   { Credits in not yet send netmail }
                  MsgsPosted    : Word;                  { # of posted msgs }
                  LastRead      : Word;            { Msg # of last msg read }
                  Security      : Word;            { Security level of user }
                  NoCalls       : Word;                        { # of calls }
                  Uploads       : Word;                      { # of uploads }
                  Downloads     : Word;                    { # of downloads }
                  UploadsK      : Word;                     { KB's uploaded }
                  DownloadsK    : Word;                   { KB's downloaded }
                  TodayK        : Integer;               { Today downloaded }
                  Elapsed       : Word;             { Total time used today }
                  ScreenLength  : Word;                  { Length of screen }
                  LastPwdChange : Byte;  { # of calls since last pwd change }
                  Attribute2    : Byte;             { 2nd set of attributes }
                                                       { Bit 0: HotKey mode }
                                                     { Bit 1 : AVATAR AVT/0 }
                                                { Bit 2 : Full-scrn msgview }
                                             { Bit 3 : Hidden from userlist }
                  Group         : Byte;                             { Group }
                  XIrecord      : Word;  { Pointer to record in USERSXI.BBS }

                  ExtraSpace    : Array[1..3] of Byte;         { Future use }
                End;  { UsersRecord_Pb130 }

  UsersXIRecord_Pb130 = Record                                { USERSXI.BBS }
                    Handle       : String[35];                { Users alias }
                    Comment      : String[80];           { Comment to sysop }
                    FirstDate    : Date;               { Date of first call }
                    CombinedInfo : CombinedRecord_Pb200;{ Combined messages }
                    BirthDate    : Date;                    { Date of birth }
                    SubDate      : Date;  { User's subscription expiry date }
                    ScreenWidth  : Byte;                  { Width of screen }
                    MsgArea      : Byte;                { Last msgarea used }
                    FileArea     : Byte;               { Last filearea used }
                    Language     : Byte;                         { Language }
                    DateFormat   : Byte;                      { Date format }
                    ForwardTo    : String[35];          { Forward msgs to.. }
                    ExtraSpace   : Array[1..43] of Byte;           { Unused }
                  End;  { UsersXIRecord_Pb130 }


  SysInfoRecord_PB200 = Record                                { SYSINFO.BBS }
                    TotalCalls  : LongInt;          { Total calls to system }
                    LastCaller  : String[35];         { Name of last caller }
                    ExtraSpace  : Array[1..128] of Byte;       { Future use }
                  End;  { SysInfoRecord_PB200 }


  TimeLogRecord_PB200 = Record                                { TIMELOG.BBS }
                    StartDate   : Date;                     { Date of start }
                    BusyPerHour : Array[0..23] of Word;    { Mins used/hour }
                    BusyPerDay  : Array[0..6] of Word;       { Not used yet }
                  End;  { TimeLogRecord_PB200 }


  EventRecord_PB200 = Record                                    { EVENTS.RA }
                     Status      : Byte;                  { Status of event }
                                                                { 0=Deleted }
                                                                { 1=Enabled }
                                                               { 2=Disabled }
                     StartTime   : Time;              { Time to start event }
                     ErrorLevel  : Byte;               { Errorlevel to exit }
                     Days        : Byte;                { Days to be active }
                     Forced      : Boolean;                   { Force event }
                     LastTimeRun : Date;                 { Date of last run }
                   End;  { EventRecord_PB200 }

  OnlineRecord_PB200 = Record                                  { ONLINE.PRO }
                     Name   : Chr36;                  { Name of user online }
                     City   : Chr16;                  { City of user online }
                     Baud   : Integer;                 { Baud rate of user  }
                     Status : Integer;     { 0 -> online , <0 -> not online }
                     Extra  : Array[1..8] of Char;
                   end;

  EventRecordArray = Array[1..20] of EventRecord_PB200;         { EVENTS.RA }

  ExitInfoRecord_PB200 = EXITINFORecord;

  ExitInfoRecord_PB130 = Record                              { EXITINFO.BBS }
          Baud            : Word;                     { BaudRate }
          SysInfo         : SysInfoRecord;         { System info }
          TimeLogInfo     : TimeLogRecord;       { Time log info }
          UserInfo        : UsersRecord_PB130;           { User record }
          EventInfo       : EventRecord;       { Next event info }
          NetMailEntered  : Boolean;      { User entered netmail }
          EchoMailEntered : Boolean;     { User entered echomail }
          LoginTime       : Time;          { Time user logged on }
          LoginDate       : Date;          { Date user logged on }
          TimeLimit       : Word; { Time user has left for today }
          LoginSec        : LongInt;   { Seclvl of user at logon }
          Credit          : LongInt;   { Credit on users accound }
          UserRecord      : Integer;     { Record # in USERS.BBS }
          ReadThru        : Word;              { Readthru status }
          NumberPages     : Word;    { # of times user has paged }
          DownloadLimit   : Word;     { Users DL restr for today }
          TimeOfCreation  : Time; { Time of creation of EXITINFO }
          LogonPassword   : String[15];{ Password user logged on }
          WantChat        : Boolean;   { Unanswered chat request }
          DeductedTime    : Integer;             { Deducted time }
          MenuStack       : Array[1..50] of String[8]; { Menustk }
          MenuStackPointer: Byte;         { Pointer to menustack }
          UserXIinfo      : UsersXIRecord_PB130;          { UserXIinfo }
          ErrorFreeConnect: Boolean;     { Error free connection }
          SysopNext       : Boolean;         { True if sysopnext }
          EMSI_Session    : Boolean;              { EMSI session }
          EMSI_Crtdef     : String[40];     { EMSI scrn settings }
          EMSI_Protocols  : String[40];         { Protocol flags }
          EMSI_Capabilities : String[40];     { Capability flags }
          EMSI_Requests   : String[40];          { Request flags }
          EMSI_Software   : String[40];          { Used software }
          Hold_Attr1      : Byte;        { Hold attributes set 1 }
          Hold_Attr2      : Byte;        { Hold attributes set 2 }
          Hold_Len        : Byte;                  { Hold length }
          ExtraSpace      : Array[1..100] of Byte;{ Not used yet }
        End;  { ExitInfoRecord }

  PB_Version = (Unknown, Pb200, Pb130);
  Str2       = String[2];


Const  LogError : boolean = false;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)
Var
  ExitInfo_PB200    : ExitInfoRecord_PB200;
  ExitInfo_PB130    : ExitInfoRecord_PB130 absolute ExitInfo_PB200;
  PBVersion         : PB_Version;
  OMode             : byte;             { for Filemode-access }
(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)
{ Patch-procedure to patch new code-addresses into RADU-procs/funcs }
Procedure Patch(OldP, NewP : Pointer); assembler;
  asm
    push ax
    push es
    push di
    mov ax, word [OldP+2]
    mov di,word [OldP]
    mov es,ax
    mov al,0eah
    mov byte [es:di],al
    inc di
    mov ax,word [NewP]
    mov word [es:di], ax
    inc di
    inc di
    mov ax,word [NewP+2]
    mov word [es:di],ax
    pop di
    pop es
    pop ax
  end;
(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

{ Function to convert a byte value <100 to a 2-char-string with leading 0 }
Function Zwei( Zahl : byte ) : Str2; Assembler;
   Asm
	mov	al,[Zahl]
	les	di,@Result
	cmp	al,99d
	jbe	@InRange
	mov	ax,'??'
	jmp	@NoRange
    @InRange:
        AAM
	add	ax,3030h
	xchg	ah,al
    @NoRange:
        mov	byte ptr es:[di],2
	inc	di
	mov	es:[di],ax
     end;

Procedure PB200Log(W : String); Far;
Const MonthInt : Array[1..12] of String[3] =
                 ('Jan','Feb','Mar','Apr','May','Jun',
                  'Jul','Aug','Sep','Oct','Nov','Dec');
Var f     : file;
    r     : word;
    Dtime : DateTime;

begin
    if (RAConfig.Logfilename<>'') and (not LogError) then
    begin
      Assign(f, RAConfig.Logfilename);
      OMode    := Filemode;
      FileMode := WriteMode + DenyWrite;
      reset(f,1);
      if IoResult = 0 then seek(f, FileSize(f)) else rewrite(f,1);
      FileMode := OMode;
      if InOutRes = 0 then
      begin
        With DTime do
        begin
          GetDate(Year, Month, Day, r);
          GetTime(Hour, Min, Sec, r);
          if Year < 2000 then r:=Year-1900 else r:=Year-2000;
          w := Zwei(Lo(Day))+'-' + MonthInt[Month] + '-' + Zwei(Lo(r))+' '+
               Zwei(Lo(Hour))+':'+Zwei(Lo(Min))+':'+Zwei(Lo(Sec))+
               ' '+W+#13#10;
        end;
        BlockWrite(f, W[1], Length(w), r);
        Close(f);
        if IoResult <> 0 then ;
      end else LogError := IoResult < 4;
    end;
end;

Procedure WrEx; Far;  { Dummy, not used at the moment }
begin end;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ReadDorInfo;
Var
  DorInfo     : Text;
  Line        : String[80];
  Line2       : String[50];
  UserOnF     : File of UserOnRecord;
  Dirinfo     : Searchrec;
  Code        : Integer;

Begin { ReadDorInfo }

  OMode    := Filemode;
  FileMode:=ReadMode+DenyWrite;

   FindFirst(ForceBack(CurPath)+'DORINFO?.DEF',Archive,Dirinfo);
   if doserror = 0 then Assign (DorInfo,Curpath+DirInfo.Name)
  Else
    Begin
      FindFirst(ForceBack(RaSystem)+'DORINFO?.DEF',Archive,Dirinfo);
      If doserror = 0 then Assign (DorInfo,RaSystem+DirInfo.Name);
    End;

  Reset(DorInfo);
  FileMode:=OMode;
  If IoResult=0 then
  Begin
    ReadLn (DorInfo,Line);
    ReadLn (DorInfo,Line);
    ReadLn (DorInfo,Line);
    ReadLn (DorInfo,Line);
    DorCommPort:=Ord(Line[4])-Ord('0');
    DorInfRead:=True;
    Close (DorInfo);
  End; { If }
End;  { ReadDorInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ReadExitInfo_PB200;

Var
  ExitFil     : File;
  Bytes       : Word;
  Dirinfo     : SearchRec;

Begin { ReadExitInfo }
  FindFirst(ExitPath,Archive,Dirinfo);
  if DosError <> 0 then Exit;

  Case DirInfo.Size of
  SizeOf(ExitInfoRecord_PB200) : begin PBVersion := PB200; PB_Ver := '2.xx';end;
  SizeOf(ExitInfoRecord_PB130) : begin PBVersion := PB130; PB_Ver := '1.3x';end;
  else PBVersion := Unknown;
  end;

  (* If Dirinfo.Size <> SizeOf(ExitInfoRecord_PB200) Then {1493 Then} *)
  if PBVersion = Unknown then
    Begin
      Writeln (' Error on EXITINFO.BBS! (WRONG VERSION)');
      Halt;
    End;

  OMode    := Filemode;
  FileMode:=ReadMode+DenyWrite;
  Assign (ExitFil,ExitPath);
  Reset (ExitFil,1);
  FileMode:=OMode;

  If IOResult>0 then
  Begin
    WriteLn (' Error opening EXITINFO.BBS! (READ)');
    Halt;
  End;  { If }
  BlockRead (ExitFil,ExitInfo_PB200,SizeOf (ExitInforecord_PB200),Bytes);
  Close (ExitFil);
  if PBVersion = PB200 then
  begin
    Exitinfo := Exitinfo_PB200;
    If ExitInfo.TimeLimit=0 then ExitInfo.TimeLimit:=1;
    ExitInfo.StatusLine := 1;
    DorAnsi:=ExitInfo.UserInfo.Attribute and 8=8;
    DorAvatar:=ExitInfo.UserInfo.Attribute2 and 2=2;
  end else
  begin
     Move(ExitInfo_Pb130.Sysinfo, ExitInfo.SysInfo, SizeOf(SysInfoRecord));
     ExitInfo.Baud := ExitInfo_Pb130.Baud;
     ExitInfo.UserInfo.Name := ExitInfo_Pb130.UserInfo.Name;
     ExitInfo.UserInfo.Location := ExitInfo_Pb130.UserInfo.Location;
     ExitInfo.UserInfo.Handle := ExitInfo_Pb130.UserXIinfo.Handle;
     ExitInfo.UserInfo.Comment := ExitInfo_Pb130.UserXIinfo.Comment;
     FillChar(ExitInfo.UserInfo.DataPhone, 30, #0);
     ExitInfo.UserInfo.DataPhone := ExitInfo_Pb130.UserInfo.DataPhone;
     ExitInfo.UserInfo.VoicePhone := ExitInfo_Pb130.UserInfo.VoicePhone;
     ExitInfo.UserInfo.LastTime := ExitInfo_Pb130.UserInfo.LastTime;
     ExitInfo.UserInfo.LastDate := ExitInfo_Pb130.UserInfo.LastDate;
     ExitInfo.UserInfo.Attribute := ExitInfo_Pb130.UserInfo.Attribute;
     ExitInfo.UserInfo.Attribute2 := ExitInfo_Pb130.UserInfo.Attribute2 AND $0F;
     Move(ExitInfo_Pb130.UserInfo.Flags,ExitInfo.UserInfo.Flags,SizeOf(FlagType));
     ExitInfo.UserInfo.Credit := LongInt(ExitInfo_Pb130.UserInfo.Credit);
     ExitInfo.UserInfo.MsgsPosted := ExitInfo_Pb130.UserInfo.MsgsPosted;
     ExitInfo.UserInfo.Security := ExitInfo_Pb130.UserInfo.Security;
     ExitInfo.UserInfo.LastRead := LongInt(ExitInfo_Pb130.UserInfo.LastRead);
     ExitInfo.UserInfo.NoCalls := LongInt(ExitInfo_Pb130.UserInfo.NoCalls);
     ExitInfo.UserInfo.Uploads := LongInt(ExitInfo_Pb130.UserInfo.Uploads);
     ExitInfo.UserInfo.Downloads := LongInt(ExitInfo_Pb130.UserInfo.Downloads);
     ExitInfo.UserInfo.UploadsK := LongInt(ExitInfo_Pb130.UserInfo.UploadsK);
     ExitInfo.UserInfo.DownloadsK := LongInt(ExitInfo_Pb130.UserInfo.DownloadsK);
     ExitInfo.UserInfo.TodayK := LongInt(ExitInfo_Pb130.UserInfo.TodayK);
     ExitInfo.UserInfo.Elapsed  := Integer(ExitInfo_Pb130.UserInfo.Elapsed);
     ExitInfo.UserInfo.ScreenLength := ExitInfo_Pb130.UserInfo.ScreenLength;
     ExitInfo.UserInfo.Group := Word(ExitInfo_Pb130.UserInfo.Group);
     ExitInfo.UserInfo.FirstDate := ExitInfo_Pb130.UserXIinfo.FirstDate;
     ExitInfo.UserInfo.BirthDate := ExitInfo_Pb130.UserXIinfo.BirthDate;
     ExitInfo.UserInfo.ScreenWidth := ExitInfo_Pb130.UserXIinfo.ScreenWidth;
     ExitInfo.UserInfo.Language := ExitInfo_Pb130.UserXIinfo.Language;
     ExitInfo.UserInfo.DateFormat := ExitInfo_Pb130.UserXIinfo.DateFormat;
     ExitInfo.UserInfo.FileArea := ExitInfo_Pb130.UserXiInfo.FileArea;
     Move(ExitInfo_Pb130.EventInfo, ExitInfo.EventInfo, SizeOf(EventRecord));
     ExitInfo.TimeLimit := ExitInfo_Pb130.TimeLimit;
     ExitInfo.DownloadLimit := ExitInfo_Pb130.DownloadLimit;
     ExitInfo.LoginSec := ExitInfo_Pb130.LoginSec;
     ExitInfo.WantChat := ExitInfo_Pb130.WantChat;
     ExitInfo.DeductedTime := 0;
     ExitInfo.ErrorFreeConnect := ExitInfo_Pb130.ErrorFreeConnect;
     ExitInfo.SysopNext := ExitInfo_Pb130.SysopNext;
     Move(ExitInfo_Pb130.EMSI_Session, ExitInfo.EMSI_Session,201);
     ExitInfo.StatusLine := 1;
  end;

  DorAnsi:=ExitInfo.UserInfo.Attribute and 8=8;
  DorAvatar:=ExitInfo.UserInfo.Attribute2 and 2=2;
  ExitInfRead:=True;
End;  { ReadExitInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure WriteExitInfo_PB200;

Var
(*  ExitFil     : File of ExitInfoRecord_PB200;*)
  ExitFil       : file;
  Bytes         : word;

Begin { WriteExitInfo }
    OMode    := Filemode;
    FileMode:=ReadWriteMode+DenyAll;
    Assign (ExitFil,ExitPath);
    ReWrite (ExitFil,1);
    FileMode:=OMode;
    If IOResult>0 then
    Begin
      WriteLn ('Error while opening: ',ExitPath,' (Write)');
      WriteLn ('Please check this out and run again.');
      Write   (^G);
      Halt;
    End;  { If }
    if PBVersion = PB200 then
      BlockWrite(ExitFil, ExitInfo, SizeOf(ExitInfoRecord), Bytes)
    else
    begin
       Move(ExitInfo.UserInfo.Flags,ExitInfo_Pb130.UserInfo.Flags,SizeOf(FlagType));
       ExitInfo_Pb130.UserInfo.Security := ExitInfo.UserInfo.Security;
       ExitInfo_Pb130.UserInfo.Elapsed  := Integer(ExitInfo.UserInfo.Elapsed);
       ExitInfo_Pb130.TimeLimit := ExitInfo.TimeLimit;
       ExitInfo_Pb130.DownloadLimit := ExitInfo.DownloadLimit;
       ExitInfo_Pb130.LoginSec := ExitInfo.LoginSec;
       ExitInfo_Pb130.WantChat := ExitInfo.WantChat;
       ExitInfo_Pb130.DeductedTime := ExitInfo.DeductedTime;
       ExitInfo.UserInfo.Uploads := Word(ExitInfo_Pb130.UserInfo.Uploads);
       Exitinfo_Pb130.UserInfo.Downloads := Word(ExitInfo.UserInfo.Downloads);
       Exitinfo_Pb130.UserInfo.UploadsK := Word(ExitInfo.UserInfo.UploadsK);
       Exitinfo_Pb130.UserInfo.DownloadsK := Word(ExitInfo.UserInfo.DownloadsK);
       Exitinfo_Pb130.UserInfo.TodayK := Integer(ExitInfo.UserInfo.TodayK);
       ExitInfo_Pb130.SysopNext := ExitInfo.SysopNext;
       ExitInfo_Pb130.TimeOfCreation := Exitinfo.TimeOfCreation;
       ExitInfo.TimeOfCreation:=TimeStr(False,False);
       BlockWrite (ExitFil,ExitInfo_Pb130,SizeOf(ExitInfoRecord_PB130),Bytes);
    end;
    Close (ExitFil);
    if IoResult <> 0 then
    begin
      writeln('Error on EXITINFO.BBS (write)');
      writeln('Please check it out!'^G^G^G);
      Halt;
    end;
End;  { WriteExitInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Convert_TimeByte( PBTime : TimeByte ) : time;
Var Hours,Minutes : String[2];
Begin
  Str(PBtime[1],Hours);
  if length(Hours) < 2 then Hours := '0'+Hours;
  Str(PBtime[2],Minutes);
  if length(Minutes) < 2 then Minutes := '0'+Minutes;
  Convert_TimeByte := Hours+':'+Minutes;
End;


Function Dow : byte; assembler;                          { returns day of week }
asm
  mov ah, 02ah
  int 21h
end;

                   { Procedure to check whether chat/download-hours are active }
                { at the actual time! If not, start and end will return a time-}
             { frame one hour *before* the actual time, so no chat is possible }

Procedure Check_TimeFrame( DayF : DayFrame; var PStart, PEnd : time );
Var Hour, Minute, Second, Sec100 : word;
    TfByte, TfBit : byte;

    Function ConvTime : time;
    var h, m : string[2];
    begin
      Str(Hour:2, h);  if Hour < 10 then h[1]:='0';
      Str(Minute:2,m); if Minute < 10 then m[1] := '0';
      ConvTime := h+':'+m;
    end;

begin { Check_TimeFrame }
   GetTime( Hour, Minute, Second, Sec100 );               { the actual time! }
   TfByte := Hour div 4;
   TfBit  := 1 shl Pred(( Succ(( Hour mod 4 ) shl 1 )) + Byte(Minute>=30));
                                                                { hups! ,-)) }
   if Minute < 30 then Minute := 0 else Minute := 30;
   if ( DayF[TfByte] and TfBit = TfBit ) then         { ok, inside the frame }
   begin
     PStart := ConvTime;
     if Minute > 0 then dec(Minute) else       { 1 minute before actual time }
     begin if Hour > 0 then dec(Hour) else Hour := 0; Minute := 59; end;
     repeat
      inc(Minute, 30);
      if  Minute >= 60 then
      begin inc(Hour); dec(Minute,60); end;
      if Hour > 23 then begin Hour := 23; Minute := 59;end;
      TfBit := TfBit shl 1;
      if TfBit = 0 then
      begin TfBit := 1; inc(TfByte); end;
     until (TfByte>=6) or (DayF[TfByte] and TfBit <> TfBit);
     PEnd := ConvTime;
   end else                         { not in the frame, set start and end to }
   begin                                       { one hour before actual time }
     if Hour > 1 then                              { or, if 0, to 23 o'clock }
       dec(Hour) else Hour := 23;
     PStart := ConvTime;
     inc(Minute); if Minute>=60 then
     begin inc(Hour);Minute:=0;if Hour >=24 then Hour:=0;end;
     PEnd   := ConvTime;
   end;
end;

Function Convert_Int_To_ask( Intege : Integer ): AskType;
Begin
  Case Intege of
   0: Convert_Int_To_Ask := Yes;
   1: Convert_Int_To_Ask := No;
   2: Convert_Int_To_Ask := Ask;
   3: Convert_Int_To_Ask := Only;
  end;
End;

Function Convert_Bol_To_ask( Bol : Boolean ): AskType;
Begin
  Case Bol of
   True  : Convert_Bol_To_Ask := Yes;
   False : Convert_Bol_To_Ask := No;
  end;
End;

Function Convert_Int_To_Bol( Intege : Integer ): Boolean;
Begin
  Case Intege of
   0 : Convert_Int_To_Bol := False;
   1 : Convert_Int_To_Bol := True;
  end;
End;

Procedure ReadConfig_PB200;
Var
  PBConfigFile      : File;
  PBConfig          : ConfigRecord_PB200;
  PBModemFile       : File;
  PBModem           : Modemrecord_PB200;
  PBAkaFile         : File;
  PBAka             : NetAddress;
  Count             : Byte;

Begin
  OMode    := Filemode;
  FileMode:=ReadMode+DenyWrite;
  Assign (PBConfigFile,RaSystem+'CONFIG.PRO');
  Reset (PBConfigFile,1);
  FileMode:=OMode;
  If IOResult>0 then
  Begin
    WriteLn (' Error opening CONFIG.PRO! (READ)');
    Halt;
  End;  { If }

  BlockRead (PBConfigFile,PBConfig,SizeOf (PBConfig));
  Close (PBConfigFile);

  OMode    := Filemode;
  FileMode:=ReadMode+DenyWrite;
  Assign (PBModemFile,ForceBack(CurPath)+'MODEM.PRO');
  Reset (PBModemFile,1);
  FileMode:=OMode;

  If IOResult>0 then
  Begin
    OMode    := Filemode;
    FileMode:=ReadMode+DenyWrite;
    Assign (PBmodemFile,RaSystem+'MODEM.PRO');
    Reset (PBModemFile,1);
    FileMode:=OMode;
    If IOResult>0 then
      Begin
        WriteLn (' Error opening MODEM.PRO! (READ)');
        Halt;
      End;
  End;  { If }
  BlockRead (PBModemFile,PBModem,SizeOf (PBModem));
  Close (PBModemFile);
  FillChar( Modem, SizeOf(Modem), 0);
  With Modem do
  begin
    ComPort     := Byte(PBModem.Port);
    InitTries   := 3;
    ModemDelay  := PBModem.Delay;
    MaxSpeed    := PBModem.Baud;
    InitStr     := AsciizToStr(PBModem.InitString);
    InitStr2    := AsciizToStr(PBModem.InitString2);
    BusyStr     := AsciizToStr(PBModem.BusyString);
    InitResp    := AsciizToStr(PBModem.InitOK);
    BusyResp    := AsciizToStr(PBModem.BusyOK);
    Connect300  := AsciizToStr(PBModem.Connect300);
    Connect1200 := AsciizToStr(PBModem.Connect1200);
    Connect2400 := AsciizToStr(PBModem.Connect2400);
    Connect4800 := AsciizToStr(PBModem.Connect4800);
    Connect7200 := AsciizToStr(PBModem.Connect7200);
    Connect9600 := AsciizToStr(PBModem.Connect9600);
    Connect12k  := AsciizToStr(PBModem.Connect12000);
    Connect14k  := AsciizToStr(PBModem.Connect14400);
    Connect16k  := AsciizToStr(PBModem.Connect16800);
    Connect19k  := AsciizToStr(PBModem.Connect19200);
    Connect38k  := AsciizToStr(PBModem.Connect38400);
    RingStr     := AsciizToStr(PBModem.Ring);
    AnswerStr   := AsciizToStr(PBModem.Answer);
    ErrorFreeString  := 'ARQ';
  end;

  FillChar (Raconfig, SizeOf(Raconfig), #0);
  With Raconfig Do
   Begin

    if PBVersion = PB200 then
    begin
        Check_TimeFrame(PBConfig.DownloadHours[Dow],
                        DownloadTimeStart, DownloadTimeEnd);
        For Count := 0 to 5 do                    { RA: sunday=0; PB: sunday=6 }
         With PBConfig do
         begin
            Check_TimeFrame(PagingHours[Count],
                            PageStart[Count+1],PageEnd[Count+1]);
         end;
         With PBConfig do Check_TimeFrame(PagingHours[6],
                                          PageStart[0],PageEnd[0]);
    end else
    begin
        DownloadTimeStart   := Convert_TimeByte(PBConfig.Dl_Start);
        DownloadTimeEnd     := Convert_TimeByte(PBConfig.Dl_End);
        For Count := 0 to 6 do
          Begin
            PageStart[Count]:= Convert_TimeByte(PBConfig.Page_Start);
            PageEnd[Count]  := Convert_TimeByte(PBConfig.Page_End);
          End;
    end;

    MenuPath            := AsciizToStr(PBConfig.Mnupath);
    TextPath            := AsciizToStr(PBConfig.TxtPath);
    NodelistPath        := AsciizToStr(PBConfig.NodelistDir);
    MsgBasePath         := AsciizTostr(PBConfig.MSGPath);
    SysPath             := GetEnv('PROBOARD');
    ExternalEdCmd       := AsciizToStr(PBConfig.Editorname);
    SystemName          := AsciizToStr(PBConfig.BBSname);
    NewSecurity         := PBConfig.NewUserLevel;
    Move(PBConfig.NewUserFlags, NewFlags, SizeOf(FlagType));
    OriginLine          := AsciizToStr(PBConfig.Originline);
    QuoteString         := AsciizToStr(PBConfig.QuoteString);
    Sysop               := AsciizToStr(PBConfig.Sysopname);
    LogFileName         := ForceBack(CurPath)+'PROBOARD.LOG';
    FastLogon           := PBConfig.Allowquicklogin;
    AllowSysRem         := FastLogon;
    DirectWrite         := PBConfig.Fastmode;
    UserTimeOut         := PBConfig.Inactivity_time;
    PasswordTries       := PBConfig.Max_Passinput;
    MaxPage             := PBConfig.Max_Sysop_Pages;
    PageLength          := PBConfig.PageBell_Length;
    ExcludeSysopFromList:= Convert_Int_To_Bol (PBConfig.Discrete);
    OneWordNames        := Convert_Int_To_Bol (PBConfig.AllowOneWord);
    CheckMail           := Convert_Int_To_Ask (PBConfig.MailCheck);
    AskVoicePhone       := Convert_Int_To_Bol (PBConfig.AskPhone);
    AskDataPhone        := Convert_Int_To_Bol (PBConfig.AskPhone);
    AllowFileShells     := True;
    ANSI                := Convert_Bol_To_Ask (PBConfig.AllowAnsi);
    ClearScreen         := Yes;
    MorePrompt          := Yes;
    UploadMsgs          := False;
    KillSent            := No;
    CrashSec            := PBConfig.CrashLevel;
    Move(PBConfig.CrashFlags, CrashFlags, SizeOf(FlagType));
    FAttachSec          := PBConfig.AttachLevel;
    Move(PBConfig.AttachFlags, FAttachFlags, SizeOf(FlagType));
    MultiLine           := PBConfig.MultiLine;
    MinPwdLen           := PBConfig.Min_Passlength;
    MinUpSpace          := PBConfig.UploadSpace;
    LogStyle            := 0;
    PwdBoard            := PBConfig.SecurityBoard;
    WhyPage             := True;
    LeaveMsg            := PBConfig.PageArea;
    LogonPrompt         := 'Enter your first *and* last name: ';
    CheckNewFiles       := Yes;
    BlankSecs           := PBModem.BlankTime;
    LeftBracket         := '[';
    RightBracket        := ']';
    AVATAR              := Convert_Bol_to_Ask (PBConfig.AllowAvatar);
    BadPwdArea          := PBConfig.SecurityBoard;
    DoAfterAction       := 1;
    FullMsgView         := No;
    EchoChar            := PbConfig.PwdChar;
    UseXMS              := True;
    UseEMS              := True;

    NormFore            := 11;
    NormBack            := 3;
    StatFore            := 0;
    StatBack            := 7;
    HiFore              := 7;
    HiBack              := 0;
    WindFore            := 7;
    WindBack            := 0;
    BorderFore          := 7;
    BorderBack          := 0;
    BarFore             := 7;
    BarBack             := 0;
    CRfore              := 7;
    CRback              := 0;
    HilitePromptFore    := 7;
    HiLitePromptBack    := 0;
    TagFore             := 7;
    TagBack             := 0;
  End;

  OMode    := Filemode;
  FileMode:=ReadMode+DenyWrite;
  Assign (PBAkaFile,RaSystem+'AKA.PRO');
  Reset (PBAkaFile,1);
  FileMode:=OMode;
  If IOResult = 0 Then
  Begin
    Count := 0;
    While (Not Eof(PBAkaFile)) Do
      Begin
        BlockRead (PBAkaFile,PBAka,SizeOf (PBAka));
        if Count < 10 then Move(PBAka, Raconfig.Address[Count], SizeOf(PBAka));
        Inc(Count);
      End;
    Close (PBAkaFile);
  End;
End;

Function PB200Init:Boolean; far;
Var
  PBOnLineFile      : File;
  PBOnLine          : OnlineRecord_PB200;
  TempNodeNr,
  Count             : Byte;
  PBEnv             : PathStr;

Begin
  PB200Init := False;
  PB_Ver := '';
  PBEnv := GetEnv('PROBOARD');
  If PBEnv = '' then Exit;
  RaSystem := ForceBack(PBEnv);
  ClrScr;
  ReadDorinfo;
  ReadExitInfo_PB200;
  ReadConfig_PB200;

  RaNodeNr := 1;
  PBEnv := GetEnv('TASK');
  If PBEnv <> '' Then RaNodeNr := FVal(PBEnv);

  OMode    := Filemode;
  FileMode:=ReadMode+DenyWrite;
  Assign (PBOnlineFile,RaSystem+'ONLINE.PRO');
  Reset (PBOnlineFile,1);
  FileMode:=OMode;
  If IOResult = 0 then
    Begin
      Count := 1; TempNodeNr := 0;
      While (Not Eof(PBOnlineFile)) Do
        Begin
          BlockRead (PBOnlineFile,PBOnline,SizeOf (PBOnline));
          If SupCase(AsciizToStr(PBOnline.Name)) = SupCase(Exitinfo.UserInfo.Name)
             Then TempNodeNr := Count;
          Inc(Count);
        End;
      Close (PBOnlineFile);
      if IoResult = 0 then RaNodeNr := TempNodeNr;
    End;
  if PBVersion <> PB200 then DorExtKeys[18]:=DorNullProc;
  NoRalFoundErrorDisplay := False;
  Patch(@RaduSup.RaLog, @PB200130.PB200Log);
  { Patch(@Radu.Writeexitinfo, @PB200130.WrEx); }
  PB200Init   := True;
  PB_Detected := True;
End;

Procedure PB200Deinit; far;
Begin
  WriteExitInfo_PB200;
end;

Begin
  AddBBS(PB200Init, PB200DeInit, 'ProBoard');               { Add BBS }
End.
