(*
** RADU support unit for RA 1.10/1.11 systems
**
** Copyright (C) 1993 Marco Miltenburg for Prime Productions, The Netherlands
**                    All rights reserved.
**
**
**
** Last revision : May 30, 1993
*)

{$A+,B-,D-,E-,F+,I+,L-,N-,O+,R-,S-,V-}

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Unit RA111;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

interface

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Implementation

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Uses
  Radu, Dos, RaStruct, MiscRADU;

Type
  (* RemoteAccess 1.11 Combined Areas *)
  CombinedRecord_Ra111 = Array[1..25] of Byte;

  (* RemoteAccess 1.11 Useron Info *)
  UserOnRecord_Ra111   = Record
                           Name         : String[35];
                           Handle       : String[35];
                           Line         : Byte;
                           Baud         : Word;
                           City         : String[25];
                           DoNotDisturb : Boolean;
                           Status       : Byte;
                           Attribute    : Byte;
                         End; { UserOnRecord }


  (* RemoteAccess 1.11 Userbase Extra Info *)
  UsersXIRecord_Ra111 = Record
                          Handle       : String[35];
                          Comment      : String[80];
                          FirstDate    : Date;
                          CombinedInfo : CombinedRecord_Ra111;
                          BirthDate    : Date;
                          SubDate      : Date;
                          ScreenWidth  : Byte;
                          MsgArea      : Byte;
                          FileArea     : Byte;
                          Language     : Byte;
                          DateFormat   : Byte;
                          ForwardTo    : String[35];
                          ExtraSpace   : Array[1..43] of Byte;
                        End; { UsersXIRecord_Ra111 }

  (* RemoteAccess 1.11 Userbase *)
  UsersRecord_Ra111 = Record
                        Name          : String[35];
                        Location      : String[25];
                        Password      : String[15];
                        DataPhone     : String[12];
                        VoicePhone    : String[12];
                        LastTime      : Time;
                        LastDate      : Date;
                        Attribute     : Byte;
                                                           { Bit 0: Deleted }
                                             { Bit 1: Screen clearing code  }
                                                  { Bit 2: Continue [Y/n/=] }
                                                     { Bit 3: Ansi graphics }
                                              { Bit 4: Don't kill user ever }
                                       { Bit 5: Ignore download restictions }
                                                { Bit 6: Full screen editor }
                                                        { Bit 7: Quiet mode }
                        Flags         : FlagType;
                        Credit        : Word;
                        Pending       : Word;
                        MsgsPosted    : Word;
                        LastRead      : Word;
                        Security      : Word;
                        NoCalls       : Word;
                        Uploads       : Word;
                        Downloads     : Word;
                        UploadsK      : Word;
                        DownloadsK    : Word;
                        TodayK        : Integer;
                        Elapsed       : Word;
                        ScreenLength  : Word;
                        LastPwdChange : Byte;
                        Attribute2    : Byte;
                                                       { Bit 0: HotKey mode }
                                                     { Bit 1 : AVATAR AVT/0 }
                                                { Bit 2 : Full-scrn msgview }
                                             { Bit 3 : Hidden from userlist }
                        Group         : Byte;
                        XIrecord      : Word;

                        ExtraSpace    : Array[1..3] of Byte;
                      End; { UsersRecord_Ra111 }

  (* RemoteAccess 1.11 ExitInfo *)
  ExitInfoRecord_Ra111 = Record
                           Baud            : Word;
                           SysInfo         : SysInfoRecord;
                           TimeLogInfo     : TimeLogRecord;
                           UserInfo        : UsersRecord_Ra111;
                           EventInfo       : EventRecord;
                           NetMailEntered  : Boolean;
                           EchoMailEntered : Boolean;
                           LoginTime       : Time;
                           LoginDate       : Date;
                           TimeLimit       : Word;
                           LoginSec        : LongInt;
                           Credit          : LongInt;
                           UserRecord      : Integer;
                           ReadThru        : Word;
                           NumberPages     : Word;
                           DownloadLimit   : Word;
                           TimeOfCreation  : Time;
                           LogonPassword   : String[15];
                           WantChat        : Boolean;
                           DeductedTime    : Integer;
                           MenuStack       : Array[1..50] of String[8];
                           MenuStackPointer: Byte;
                           UserXIinfo      : UsersXIRecord_Ra111;
                           ErrorFreeConnect: Boolean;
                           SysopNext       : Boolean;
                           EMSI_Session    : Boolean;
                           EMSI_Crtdef     : String[40];
                           EMSI_Protocols  : String[40];
                           EMSI_Capabilities : String[40];
                           EMSI_Request    : String[40];
                           EMSI_Software   : String[40];
                           Hold_Attr1      : Byte;
                           Hold_Attr2      : Byte;
                           Hold_Len        : Byte;
                           ExtraSpace      : Array[1..100] of Byte;
                         End; { ExitInfoRecord_Ra111 }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Var
  ExitInfo_Ra111    : ExitInfoRecord_Ra111;

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ReadDorInfo;

Var
  DorInfo     : Text;
  Line        : String[80];
  Line2       : String[50];
  UserOnF     : File of UserOnRecord;

Begin { ReadDorInfo }

  FileMode:=ReadMode+DenyWrite;

  If RaConfig.MultiLine then
    Assign (DorInfo,CurPath+'DorInfo1.Def')
  Else
    Assign (DorInfo,RaSystem+'DorInfo1.Def');

  {$I-} Reset(DorInfo); {$I+}
  FileMode:=ReadWriteMode;
  If IoResult=0 then
  Begin
    ReadLn (DorInfo,Line);
    ReadLn (DorInfo,Line);
    ReadLn (DorInfo,Line);
    ReadLn (DorInfo,Line);
    DorCommPort:=Ord(Line[4])-Ord('0');

    DorInfRead:=True;
    Close (DorInfo);
  End; { If }
End;  { ReadDorInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ReadExitInfo_ra111;

Var
  ExitFil     : File;
  Bytes       : Word;

Begin { ReadExitInfo }
  FileMode:=ReadMode+DenyWrite;
  Assign (ExitFil,ExitPath);
  {$I-} Reset (ExitFil,1); {$I+}
  FileMode:=ReadWriteMode;

  If IOResult>0 then
  Begin
    WriteLn (' Error opening EXITINFO.BBS! (READ)');
    Halt;
  End;  { If }

  BlockRead (ExitFil,ExitInfo_ra111,SizeOf (ExitInforecord_ra111),Bytes);
  Close (ExitFil);

  If ExitInfo.TimeLimit=0 then
    ExitInfo.TimeLimit:=1;

  DorAnsi:=ExitInfo.UserInfo.Attribute and 8=8;
  DorAvatar:=ExitInfo.UserInfo.Attribute2 and 2=2;
  ExitInfRead:=True;
End;  { ReadExitInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure WriteExitInfo_ra111;

Var
  ExitFil     : File of ExitInfoRecord_RA111;

Begin { WriteExitInfo }
  Begin
    FileMode:=ReadWriteMode+DenyAll;
    Assign (ExitFil,ExitPath);
    {$I-} ReSet (ExitFil); {$I+}
    FileMode:=ReadWriteMode;

    If IOResult>0 then
    Begin
      WriteLn ('Error while opening: ',ExitPath,' (Write)');
      WriteLn ('Please check this out and run again.');
      Write   (^G^G^G);
      Halt;
    End;  { If }
    ExitInfo.TimeOfCreation:=TimeStr(False,False);
    Write (ExitFil,ExitInfo_RA111);
    Truncate(ExitFil);
    Close (ExitFil);
  End;  { If }
End;  { WriteExitInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Ra111Init:Boolean;                  { Read EXITINFO.BBS at startup }
Var
  RaVersion         : Word;
  Ra111ExitInfoFile : File;

  Ra111UserOnFile   : File;
  UserOn_Ra111      : UserOnRecord_Ra111;

Begin
  Ra111Init := False;

  (* CONFIG.RA is already read by RADU, so we only need to check if this *)
  (* is the correct version of RA, otherwise exit.                       *)
  If (RaConfig.VersionID and $fffe) <> $0110 then Exit;

  readexitinfo_ra111;
  (* Read EXITINFO.BBS from RA v1.10/v1.11 in current directory! *)
  Assign (Ra111ExitInfoFile, 'EXITINFO.BBS');
  {$I-} Reset (Ra111ExitInfoFile, 1);
        BlockRead (Ra111ExitInfoFile, ExitInfo_Ra111, SizeOf(ExitInfo_Ra111));
        Close (Ra111ExitInfoFile);
  {$I+}
  If IoResult <> 0 Then
  Begin
    RaLog('Error reading ''EXITINFO.BBS'' of RA v1.10/v1.10');
    Exit
  End; { If }

  (* Copy information from RA v1.10/v1.11 EXITINFO.BBS to the RADU       *)
  (* internal ExitInfo of RA v2.00. Please note that NOT all information *)
  (* is copied, only the most used information. If your application need *)
  (* more information, copy it in the same way.                          *)
  (* Anyway, check if the information is there before trying to access   *)
  (* it!                                                                 *)

  ExitInfo.Baud := ExitInfo_Ra111.Baud;

  Move(ExitInfo_Ra111.Sysinfo, ExitInfo.SysInfo, SizeOf(SysInfoRecord));

  ExitInfo.UserInfo.Name := ExitInfo_Ra111.UserInfo.Name;
  ExitInfo.UserInfo.Location := ExitInfo_Ra111.UserInfo.Location;
  ExitInfo.UserInfo.Handle := ExitInfo_Ra111.UserXIinfo.Handle;
  ExitInfo.UserInfo.Comment := ExitInfo_Ra111.UserXIinfo.Comment;
  FillChar(ExitInfo.UserInfo.DataPhone, 30, #0);
  ExitInfo.UserInfo.DataPhone := ExitInfo_Ra111.UserInfo.DataPhone;
  ExitInfo.UserInfo.VoicePhone := ExitInfo_Ra111.UserInfo.VoicePhone;
  ExitInfo.UserInfo.LastTime := ExitInfo_Ra111.UserInfo.LastTime;
  ExitInfo.UserInfo.LastDate := ExitInfo_Ra111.UserInfo.LastDate;
  ExitInfo.UserInfo.Attribute := ExitInfo_Ra111.UserInfo.Attribute;
  ExitInfo.UserInfo.Attribute2 := ExitInfo_Ra111.UserInfo.Attribute2 AND $0F;
  Move(ExitInfo_Ra111.UserInfo.Flags, ExitInfo.UserInfo.Flags,SizeOf(FlagType));
  ExitInfo.UserInfo.Credit := LongInt(ExitInfo_Ra111.UserInfo.Credit);
  ExitInfo.UserInfo.MsgsPosted := ExitInfo_Ra111.UserInfo.MsgsPosted;
  ExitInfo.UserInfo.Security := ExitInfo_Ra111.UserInfo.Security;
  ExitInfo.UserInfo.LastRead := LongInt(ExitInfo_Ra111.UserInfo.LastRead);
  ExitInfo.UserInfo.NoCalls := LongInt(ExitInfo_Ra111.UserInfo.NoCalls);
  ExitInfo.UserInfo.Uploads := LongInt(ExitInfo_Ra111.UserInfo.Uploads);
  ExitInfo.UserInfo.Downloads := LongInt(ExitInfo_Ra111.UserInfo.Downloads);
  ExitInfo.UserInfo.UploadsK := LongInt(ExitInfo_Ra111.UserInfo.UploadsK);
  ExitInfo.UserInfo.DownloadsK := LongInt(ExitInfo_Ra111.UserInfo.DownloadsK);
  ExitInfo.UserInfo.TodayK := LongInt(ExitInfo_Ra111.UserInfo.TodayK);
  ExitInfo.UserInfo.Elapsed  := Integer(ExitInfo_Ra111.UserInfo.Elapsed);
  ExitInfo.UserInfo.ScreenLength := ExitInfo_Ra111.UserInfo.ScreenLength;
  ExitInfo.UserInfo.Group := Word(ExitInfo_Ra111.UserInfo.Group);
  ExitInfo.UserInfo.FirstDate := ExitInfo_Ra111.UserXIinfo.FirstDate;
  ExitInfo.UserInfo.BirthDate := ExitInfo_Ra111.UserXIinfo.BirthDate;
  ExitInfo.UserInfo.ScreenWidth := ExitInfo_Ra111.UserXIinfo.ScreenWidth;
  ExitInfo.UserInfo.Language := ExitInfo_Ra111.UserXIinfo.Language;
  ExitInfo.UserInfo.DateFormat := ExitInfo_Ra111.UserXIinfo.DateFormat;

  Move(ExitInfo_Ra111.EventInfo, ExitInfo.EventInfo, SizeOf(EventRecord));

  ExitInfo.TimeLimit := ExitInfo_Ra111.TimeLimit;
  ExitInfo.LoginSec := ExitInfo_Ra111.LoginSec;
  ExitInfo.WantChat := ExitInfo_Ra111.WantChat;
  ExitInfo.DeductedTime := 0;
  ExitInfo.ErrorFreeConnect := ExitInfo_Ra111.ErrorFreeConnect;
  ExitInfo.SysopNext := ExitInfo_Ra111.SysopNext;

  Move(ExitInfo_Ra111.EMSI_Session, ExitInfo.EMSI_Session, 1 + 5*40);

  ExitInfo.StatusLine := 1;

  (* Set global variables of RADU. These are needed for RADU to work. *)
  (* The following code makes use of the TASK environment variable to *)
  (* determine the RA line number. It will also read the USERON.BBS   *)
  (* to get the line number, which will override the TASK variable.   *)
  DorCommPort := RAConfig.xCommPort;                                 {!}
  ReadDorInfo;                 { Correct COMMport setting if necassary }
  Modem.SendBreak:=RaConfig.xSendBreak;
  Modem.ErrorFreeString:=RaConfig.XErrorFreeString;                  {!}

  RaNodeNr := 1;
  If GetEnv('TASK') <> '' Then RaNodeNr := FVal(GetEnv('TASK'));

  FillChar (UserOn_Ra111, SizeOf(UserOn_Ra111), #0);
  Assign (Ra111UserOnFile, RAConfig.SysPath + 'USERON.BBS');
  {$I-} Reset (Ra111UserOnFile, 1); {$I+}
  If IoResult = 0 Then
  Begin
    While Not Eof(Ra111UserOnFile) Do
    Begin
        {$I-} BlockRead (Ra111UserOnFile, UserOn_Ra111, SizeOf(UserOn_Ra111)); {$I+}

        If (SUpCase(UserOn_Ra111.Name) = SUpCase(ExitInfo.UserInfo.Name))
        Then RaNodeNr := UserOn_Ra111.Line

    End { While }
  End; { if }
  {$I-} Close (Ra111UserOnFile); {$I+}


  (* Disable some sysop keys *)
  DorExtKeys[18]:=DorNullProc;                        { Disable User Editor }

  Ra111Init := True;
End; { Ra111Init }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure Ra111DeInit;                        { Rewrite EXITINFO.BBS for RA }
Var
  Ra111ExitInfoFile : File;

Begin
  (* Copy information from internal ExitInfo to RA v1.10/v1.11. We only    *)
  (* to store the fields that can be changed by the application. All other *)
  (* fields are still in the global defined ExitInfo_Ra111                 *)
  Move(ExitInfo.UserInfo.Flags, ExitInfo_Ra111.UserInfo.Flags, SizeOf(FlagType));
  ExitInfo_Ra111.UserInfo.Security := ExitInfo.UserInfo.Security;
  ExitInfo_Ra111.UserInfo.Elapsed  := Integer(ExitInfo.UserInfo.Elapsed);

  ExitInfo_Ra111.TimeLimit := ExitInfo.TimeLimit;
  ExitInfo_Ra111.LoginSec := ExitInfo.LoginSec;
  ExitInfo_Ra111.WantChat := ExitInfo.WantChat;
  ExitInfo_Ra111.DeductedTime := ExitInfo.DeductedTime;

  ExitInfo_Ra111.SysopNext := ExitInfo.SysopNext;

  ExitInfo_Ra111.TimeOfCreation := Exitinfo.TimeOfCreation;

  (* Write EXITINFO.BBS of RA v1.10/v1.11 *)

  WriteExitInfo_ra111;
End; { Ra111DeInit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Begin
  AddBBS(Ra111Init, Ra111DeInit, 'RA v1.10/v1.11');               { Add BBS }
End.

